aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDenys Vlasenko <vda.linux@googlemail.com>2011-10-31 01:05:16 +0100
committerDenys Vlasenko <vda.linux@googlemail.com>2011-10-31 01:05:16 +0100
commitc531b9a3e4a90fd7c91c78a6991e30bfe0134f34 (patch)
tree63883e7ad41456977664c0a4f2d3b36d980bebd7
parentb076193f741740886a6771cfe7750adb58ce18a0 (diff)
downloadbusybox-w32-c531b9a3e4a90fd7c91c78a6991e30bfe0134f34.tar.gz
busybox-w32-c531b9a3e4a90fd7c91c78a6991e30bfe0134f34.tar.bz2
busybox-w32-c531b9a3e4a90fd7c91c78a6991e30bfe0134f34.zip
bzcat: fix unpacking of more than one file, and unpacking of zero-size bz2. Closes 4393
Signed-off-by: Denys Vlasenko <vda.linux@googlemail.com>
-rw-r--r--archival/bbunzip.c7
-rw-r--r--archival/libarchive/decompress_bunzip2.c9
-rwxr-xr-xtestsuite/bzcat.tests80
-rwxr-xr-x[-rw-r--r--]testsuite/ls.mk_uni_tests0
4 files changed, 41 insertions, 55 deletions
diff --git a/archival/bbunzip.c b/archival/bbunzip.c
index 9c1a73780..853c653c0 100644
--- a/archival/bbunzip.c
+++ b/archival/bbunzip.c
@@ -103,7 +103,9 @@ int FAST_FUNC bbunpack(char **argv,
103 status = unpacker(&info); 103 status = unpacker(&info);
104 if (status < 0) 104 if (status < 0)
105 exitcode = 1; 105 exitcode = 1;
106 xclose(STDOUT_FILENO); /* with error check! */ 106
107 if (!(option_mask32 & OPT_STDOUT))
108 xclose(STDOUT_FILENO); /* with error check! */
107 109
108 if (filename) { 110 if (filename) {
109 char *del = new_name; 111 char *del = new_name;
@@ -143,6 +145,9 @@ int FAST_FUNC bbunpack(char **argv,
143 } 145 }
144 } while (*argv && *++argv); 146 } while (*argv && *++argv);
145 147
148 if (option_mask32 & OPT_STDOUT)
149 xclose(STDOUT_FILENO); /* with error check! */
150
146 return exitcode; 151 return exitcode;
147} 152}
148 153
diff --git a/archival/libarchive/decompress_bunzip2.c b/archival/libarchive/decompress_bunzip2.c
index cd3144743..c4640d489 100644
--- a/archival/libarchive/decompress_bunzip2.c
+++ b/archival/libarchive/decompress_bunzip2.c
@@ -752,7 +752,14 @@ unpack_bz2_stream(int src_fd, int dst_fd)
752 } 752 }
753 } 753 }
754 754
755 if (i != RETVAL_LAST_BLOCK) { 755 if (i != RETVAL_LAST_BLOCK
756 /* Observed case when i == RETVAL_OK:
757 * "bzcat z.bz2", where "z.bz2" is a bzipped zero-length file
758 * (to be exact, z.bz2 is exactly these 14 bytes:
759 * 42 5a 68 39 17 72 45 38 50 90 00 00 00 00).
760 */
761 && i != RETVAL_OK
762 ) {
756 bb_error_msg("bunzip error %d", i); 763 bb_error_msg("bunzip error %d", i);
757 break; 764 break;
758 } 765 }
diff --git a/testsuite/bzcat.tests b/testsuite/bzcat.tests
index 5b4f3f4b3..c1d384464 100755
--- a/testsuite/bzcat.tests
+++ b/testsuite/bzcat.tests
@@ -1,54 +1,28 @@
1#!/bin/sh 1#!/bin/sh
2 2# Copyright 2011 by Denys Vlasenko
3FAILCOUNT=0 3# Licensed under GPLv2, see file LICENSE in this source tree.
4 4
5ext=bz2 5. ./testing.sh
6 6
7bb="busybox " 7# testing "test name" "command" "expected result" "file input" "stdin"
8 8
9unset LC_ALL 9# "input" file is bzipped file with "a\n" data
10unset LC_MESSAGES 10testing "bzcat can print many files" \
11unset LANG 11"$ECHO -ne '$hexdump' | bzcat input input; echo \$?" \
12unset LANGUAGE 12"\
13 13a
14hello_gz() { 14a
15 # Gzipped "HELLO\n" 150
16 #_________________________ vvv vvv vvv vvv - mtime 16" "\
17 $ECHO -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7" 17\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x63\x3e\xd6\xe2\x00\x00\
18 $ECHO -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00" 18\x00\xc1\x00\x00\x10\x20\x00\x20\x00\x21\x00\x82\xb1\x77\x24\x53\
19} 19\x85\x09\x06\x33\xed\x6e\x20\
20 20" ""
21hello_bz2() { 21
22 # Bzipped "HELLO\n" 22# "input" file is bzipped zero byte file
23 $ECHO -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00" 23testing "bzcat can handle compressed zero-length bzip2 files" \
24 $ECHO -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97" 24"$ECHO -ne '$hexdump' | bzcat input input; echo \$?" \
25 $ECHO -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3" 25"0\n" \
26} 26"\x42\x5a\x68\x39\x17\x72\x45\x38\x50\x90\x00\x00\x00\x00" ""
27 27
28prep() { 28exit $FAILCOUNT
29 rm -f t*
30 hello_$ext >t1.$ext
31 hello_$ext >t2.$ext
32}
33
34check() {
35 eval $2 >t_actual 2>&1
36 if $ECHO -ne "$expected" | cmp - t_actual; then
37 echo "PASS: $1"
38 else
39 echo "FAIL: $1"
40 FAILCOUNT=$((FAILCOUNT + 1))
41 fi
42}
43
44mkdir testdir 2>/dev/null
45(
46cd testdir || { echo "cannot cd testdir!"; exit 1; }
47
48expected="HELLO\nok\n"
49prep; check "bzcat: dont delete src" "${bb}bzcat t2.bz2; test -f t2.bz2 && echo ok"
50
51)
52rm -rf testdir
53
54exit $((FAILCOUNT <= 255 ? FAILCOUNT : 255))
diff --git a/testsuite/ls.mk_uni_tests b/testsuite/ls.mk_uni_tests
index da0c29f29..da0c29f29 100644..100755
--- a/testsuite/ls.mk_uni_tests
+++ b/testsuite/ls.mk_uni_tests